"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FindrForm = void 0;
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("@emotion/react/jsx-runtime");
const React = tslib_1.__importStar(require("react"));
const option_button_1 = tslib_1.__importDefault(require("../option-button/option-button"));
const search_box_1 = tslib_1.__importDefault(require("../search-box/search-box"));
const replace_box_1 = tslib_1.__importDefault(require("../replace-box/replace-box"));
const replace_button_1 = tslib_1.__importDefault(require("../replace-button/replace-button"));
const ExpandMore_1 = tslib_1.__importDefault(require("@mui/icons-material/ExpandMore"));
const NavigateNext_1 = tslib_1.__importDefault(require("@mui/icons-material/NavigateNext"));
const material_1 = require("@mui/material");
const vsc_1 = require("react-icons/vsc");
const options_bar_1 = tslib_1.__importDefault(require("../options-bar/options-bar"));
const defaultSearchOptions = {
    isCaseMatched: false,
    isWordMatched: false,
    isRegex: false,
};
const defaultReplaceOptions = {
    isCasePreserved: false,
};
function FindrForm({ onChangeOptions: _onChangeOptions, onChangeTarget, onChangeReplacement, onReplaceAll, target, replacement, options, groups, }) {
    const [showReplace, setShowReplace] = React.useState(false);
    React.useEffect(() => {
        if (typeof _onChangeOptions === 'function') {
            _onChangeOptions(Object.assign(Object.assign({}, defaultSearchOptions), defaultReplaceOptions));
        }
    }, [_onChangeOptions]);
    const onChangeOptions = (event, newOptions) => {
        if (typeof _onChangeOptions === 'function')
            _onChangeOptions((options) => (Object.assign(Object.assign({}, options), newOptions)));
    };
    return ((0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ sx: {
            display: 'grid',
            gridTemplateColumns: 'auto minmax(0, 1fr)',
            gridAutoFlow: 'column',
            gap: '0.2em',
        } }, { children: [(0, jsx_runtime_1.jsx)(material_1.FormControl, Object.assign({ margin: 'dense' }, { children: (0, jsx_runtime_1.jsx)(material_1.Button, Object.assign({ title: 'toggle replace', sx: {
                        height: '100%',
                        p: 0,
                        minWidth: 'auto',
                        color: 'rgba(0, 0, 0, 0.87)',
                    }, variant: 'text', onClick: () => setShowReplace((value) => !value) }, { children: showReplace ? (0, jsx_runtime_1.jsx)(ExpandMore_1.default, {}) : (0, jsx_runtime_1.jsx)(NavigateNext_1.default, {}) })) })), (0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ sx: { display: 'grid', padding: '0em' } }, { children: [(0, jsx_runtime_1.jsx)(search_box_1.default, { defaultValue: target, onChange: typeof onChangeTarget === 'function' ? onChangeTarget : () => null, searchOptions: (0, jsx_runtime_1.jsxs)(options_bar_1.default, Object.assign({ defaultOptions: defaultSearchOptions, onChange: onChangeOptions }, { children: [(0, jsx_runtime_1.jsx)(option_button_1.default, Object.assign({ value: "isCaseMatched", title: "Match Case" }, { children: (0, jsx_runtime_1.jsx)(vsc_1.VscCaseSensitive, { size: '1.5em' }) })), (0, jsx_runtime_1.jsx)(option_button_1.default, Object.assign({ value: "isWordMatched", title: "Match Whole Word" }, { children: (0, jsx_runtime_1.jsx)(vsc_1.VscWholeWord, { size: '1.5em' }) })), (0, jsx_runtime_1.jsx)(option_button_1.default, Object.assign({ value: "isRegex", title: "Use Regular Expression" }, { children: (0, jsx_runtime_1.jsx)(vsc_1.VscRegex, { size: '1.5em' }) }))] })) }), (0, jsx_runtime_1.jsx)(material_1.Collapse, Object.assign({ in: showReplace }, { children: (0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ sx: {
                                display: 'grid',
                                gap: '0.5em',
                                gridTemplateColumns: 'minmax(0, 1fr) auto',
                            } }, { children: [(0, jsx_runtime_1.jsx)(replace_box_1.default, { defaultValue: replacement, onChange: typeof onChangeReplacement === 'function'
                                        ? onChangeReplacement
                                        : () => null, replaceOptions: (0, jsx_runtime_1.jsx)(options_bar_1.default, Object.assign({ defaultOptions: defaultReplaceOptions, onChange: onChangeOptions }, { children: (0, jsx_runtime_1.jsx)(option_button_1.default, Object.assign({ value: "isCasePreserved", title: "Preserve case" }, { children: (0, jsx_runtime_1.jsx)(vsc_1.VscPreserveCase, { size: '1.5em' }) })) })) }), (0, jsx_runtime_1.jsx)(replace_button_1.default, Object.assign({ variant: "outlined", onClick: () => {
                                        onReplaceAll({
                                            target,
                                            replacement,
                                            groups,
                                            options,
                                        });
                                    }, title: "Replace All" }, { children: (0, jsx_runtime_1.jsx)(vsc_1.VscReplaceAll, { fontSize: "1.3em" }) }))] })) }))] }))] })));
}
exports.FindrForm = FindrForm;
exports.default = FindrForm;
