"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OptionsBar = void 0;
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("@emotion/react/jsx-runtime");
const React = tslib_1.__importStar(require("react"));
const material_1 = require("@mui/material");
function OptionsBar(_a) {
    var { defaultOptions, onChange, children } = _a, props = tslib_1.__rest(_a, ["defaultOptions", "onChange", "children"]);
    const defaultValues = React.useMemo(() => Object.keys(defaultOptions).filter((option) => defaultOptions[option]), [defaultOptions]);
    const [values, setValues] = React.useState(defaultValues);
    const onChangeOptions = (event, newOptions) => {
        setValues(newOptions);
        const options = newOptions.reduce((options, keys) => {
            options[keys] = true;
            return options;
        }, Object.assign({}, defaultOptions));
        onChange(event, options);
    };
    return ((0, jsx_runtime_1.jsx)(material_1.ToggleButtonGroup, Object.assign({ "aria-label": "search options", title: "search options", size: 'small' }, props, { value: values, onChange: onChangeOptions }, { children: children })));
}
exports.OptionsBar = OptionsBar;
exports.default = OptionsBar;
