"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResultsTreeItem = void 0;
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("@emotion/react/jsx-runtime");
const React = tslib_1.__importStar(require("react"));
const x_tree_view_1 = require("@mui/x-tree-view");
const styles_1 = require("@mui/material/styles");
const material_1 = require("@mui/material");
const vsc_1 = require("react-icons/vsc");
const theme = (0, styles_1.createTheme)({
    components: {
        MuiTreeItem: {
            styleOverrides: {
                content: {
                    width: 'auto',
                },
                group: {
                    marginLeft: 0,
                },
            },
        },
    },
});
function ResultsTreeItem(_a) {
    var { itemKey, tooltip, title, content, onRenderTitle = () => null, onReplace = () => null, onDismiss = () => null, onClick = () => null, children, actions } = _a, props = tslib_1.__rest(_a, ["itemKey", "tooltip", "title", "content", "onRenderTitle", "onReplace", "onDismiss", "onClick", "children", "actions"]);
    const renderTitle = React.useCallback((items) => {
        const customItems = onRenderTitle({ items });
        return customItems || items;
    }, [onRenderTitle]);
    return ((0, jsx_runtime_1.jsx)(styles_1.ThemeProvider, Object.assign({ theme: theme }, { children: (0, jsx_runtime_1.jsx)(x_tree_view_1.TreeItem, Object.assign({ onClick: (e) => onClick(e, itemKey), label: (0, jsx_runtime_1.jsx)(material_1.Tooltip, Object.assign({ title: tooltip || '', enterDelay: 800, enterNextDelay: 800 }, { children: (0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ sx: {
                        display: 'grid',
                        gridTemplateColumns: 'minmax(0, 1fr) auto',
                        gap: 0.5,
                        p: 0.5,
                        pr: 0,
                        '&:hover': {
                            '& .action-buttons': {
                                display: 'grid',
                            },
                            '& .results-count': {
                                display: 'none',
                            },
                        },
                    } }, { children: [(0, jsx_runtime_1.jsx)(material_1.Box, Object.assign({ component: 'span', sx: {
                                display: 'inline-block',
                                alignItems: 'center',
                                p: 0.5,
                                pr: 0,
                                textOverflow: 'ellipsis',
                                position: 'relative',
                                textWrap: 'nowrap',
                                whiteSpace: 'nowrap',
                                overflow: 'hidden',
                            } }, { children: (0, jsx_runtime_1.jsxs)(material_1.Typography, Object.assign({ variant: "body2", sx: {
                                    fontWeight: 'inherit',
                                    width: 'auto',
                                    display: 'inline',
                                } }, { children: [renderTitle(title), ' ', (0, jsx_runtime_1.jsx)(material_1.Typography, Object.assign({ variant: "caption", sx: { fontWeight: 'inherit', width: 'auto' } }, { children: content }))] })) })), (0, jsx_runtime_1.jsx)(material_1.Box, Object.assign({ className: 'action-buttons', color: "inherit", sx: { display: 'none', gridAutoFlow: 'column' } }, { children: [
                                actions,
                                (0, jsx_runtime_1.jsx)(material_1.IconButton, Object.assign({ "aria-label": "Dismiss result", size: "small", title: "Dismiss", onClick: (e) => {
                                        e.preventDefault();
                                        e.stopPropagation();
                                        onDismiss(itemKey);
                                    } }, { children: (0, jsx_runtime_1.jsx)(vsc_1.VscClose, { fontSize: "inherit" }) })),
                            ]
                                .flat()
                                .map((action, index) => {
                                return ((0, jsx_runtime_1.jsx)(material_1.Box, Object.assign({ sx: { display: 'inline-block' } }, { children: action }), index));
                            }) })), (0, jsx_runtime_1.jsx)(material_1.Box, Object.assign({ className: 'results-count', color: "inherit", sx: { display: 'grid', gridAutoFlow: 'column' } }, { children: Array.isArray(children) && children.length ? ((0, jsx_runtime_1.jsx)(material_1.Chip, { label: children.length, sx: { transform: 'scale(0.8)' }, color: 'primary' })) : null }))] })) })) }, props, { nodeId: String(itemKey) }, { children: children }), itemKey) })));
}
exports.ResultsTreeItem = ResultsTreeItem;
exports.default = ResultsTreeItem;
