"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchResult = exports.Mark = void 0;
const tslib_1 = require("tslib");
const jsx_runtime_1 = require("@emotion/react/jsx-runtime");
const React = tslib_1.__importStar(require("react"));
const material_1 = require("@mui/material");
function Mark(props) {
    const { children, color, style } = props, _props = tslib_1.__rest(props, ["children", "color", "style"]);
    const defaultColor = 'rgba(0, 18, 255, 0.2)';
    const _style = {
        backgroundColor: color !== null && color !== void 0 ? color : defaultColor,
        padding: '0.1em 0.2em',
        borderRadius: '0.3em',
        border: `0.1em solid ${color !== null && color !== void 0 ? color : defaultColor}`,
        color: '#141414',
    };
    return ((0, jsx_runtime_1.jsx)("mark", Object.assign({ style: Object.assign(Object.assign({}, _style), style) }, _props, { children: children })));
}
exports.Mark = Mark;
function Match(props) {
    const { children, replaced } = props;
    const { style, color } = replaced
        ? {
            color: 'rgba(218, 54, 51, 0.3)',
            style: { textDecoration: 'line-through' },
        }
        : {};
    return ((0, jsx_runtime_1.jsx)(Mark, Object.assign({ style: style, color: color }, { children: children })));
}
function Replacement(props) {
    const { children } = props;
    const color = 'rgba(35, 134, 54, 0.3)';
    return (0, jsx_runtime_1.jsx)(Mark, Object.assign({ color: color }, { children: children }));
}
function SearchResult(props) {
    const { context = { before: '', after: '' }, match, replacement = '', ellipsis = '', minCtxWords = 5 } = props, other = tslib_1.__rest(props, ["context", "match", "replacement", "ellipsis", "minCtxWords"]);
    const { before, after } = context;
    const clippedBefore = React.useMemo(() => {
        const ctxArr = before.split(' ');
        const wordsCount = ctxArr.length;
        const selectedWordsCount = wordsCount - 1;
        const selectedCtxArr = ctxArr.slice(-selectedWordsCount);
        const wordsLimit = -minCtxWords;
        const slicedCtxArr = selectedCtxArr.slice(wordsLimit);
        const newCtxString = slicedCtxArr.join(' ');
        return newCtxString;
    }, [before, minCtxWords]);
    const clippedAfter = React.useMemo(() => {
        const ctxArr = after.split(' ');
        const wordsCount = ctxArr.length;
        const selectedWordsCount = wordsCount - 1;
        const selectedCtxArr = ctxArr.slice(0, selectedWordsCount);
        const wordsLimit = minCtxWords;
        const slicedCtxArr = selectedCtxArr.slice(0, wordsLimit);
        const newCtxString = slicedCtxArr.join(' ');
        return newCtxString;
    }, [after, minCtxWords]);
    return ((0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ component: 'span', width: '100%', variant: 'body1' }, other, { children: [ellipsis, clippedBefore, (0, jsx_runtime_1.jsx)(Match, Object.assign({ replaced: !!replacement }, { children: match })), !replacement ? null : (0, jsx_runtime_1.jsx)(Replacement, { children: replacement }), clippedAfter, ellipsis] })));
}
exports.SearchResult = SearchResult;
exports.default = SearchResult;
