import { __rest } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import * as React from 'react';
import { TreeItem } from '@mui/x-tree-view';
import { ThemeProvider, createTheme } from '@mui/material/styles';
import { Box, Chip, IconButton, Tooltip, Typography } from '@mui/material';
import { VscClose } from 'react-icons/vsc';
const theme = createTheme({
    components: {
        MuiTreeItem: {
            styleOverrides: {
                content: {
                    width: 'auto',
                },
                group: {
                    marginLeft: 0,
                },
            },
        },
    },
});
export function ResultsTreeItem(_a) {
    var { itemKey, tooltip, title, content, onRenderTitle = () => null, onReplace = () => null, onDismiss = () => null, onClick = () => null, children, actions } = _a, props = __rest(_a, ["itemKey", "tooltip", "title", "content", "onRenderTitle", "onReplace", "onDismiss", "onClick", "children", "actions"]);
    const renderTitle = React.useCallback((items) => {
        const customItems = onRenderTitle({ items });
        return customItems || items;
    }, [onRenderTitle]);
    return (_jsx(ThemeProvider, Object.assign({ theme: theme }, { children: _jsx(TreeItem, Object.assign({ onClick: (e) => onClick(e, itemKey), label: _jsx(Tooltip, Object.assign({ title: tooltip || '', enterDelay: 800, enterNextDelay: 800 }, { children: _jsxs(Box, Object.assign({ sx: {
                        display: 'grid',
                        gridTemplateColumns: 'minmax(0, 1fr) auto',
                        gap: 0.5,
                        p: 0.5,
                        pr: 0,
                        '&:hover': {
                            '& .action-buttons': {
                                display: 'grid',
                            },
                            '& .results-count': {
                                display: 'none',
                            },
                        },
                    } }, { children: [_jsx(Box, Object.assign({ component: 'span', sx: {
                                display: 'inline-block',
                                alignItems: 'center',
                                p: 0.5,
                                pr: 0,
                                textOverflow: 'ellipsis',
                                position: 'relative',
                                textWrap: 'nowrap',
                                whiteSpace: 'nowrap',
                                overflow: 'hidden',
                            } }, { children: _jsxs(Typography, Object.assign({ variant: "body2", sx: {
                                    fontWeight: 'inherit',
                                    width: 'auto',
                                    display: 'inline',
                                } }, { children: [renderTitle(title), ' ', _jsx(Typography, Object.assign({ variant: "caption", sx: { fontWeight: 'inherit', width: 'auto' } }, { children: content }))] })) })), _jsx(Box, Object.assign({ className: 'action-buttons', color: "inherit", sx: { display: 'none', gridAutoFlow: 'column' } }, { children: [
                                actions,
                                _jsx(IconButton, Object.assign({ "aria-label": "Dismiss result", size: "small", title: "Dismiss", onClick: (e) => {
                                        e.preventDefault();
                                        e.stopPropagation();
                                        onDismiss(itemKey);
                                    } }, { children: _jsx(VscClose, { fontSize: "inherit" }) })),
                            ]
                                .flat()
                                .map((action, index) => {
                                return (_jsx(Box, Object.assign({ sx: { display: 'inline-block' } }, { children: action }), index));
                            }) })), _jsx(Box, Object.assign({ className: 'results-count', color: "inherit", sx: { display: 'grid', gridAutoFlow: 'column' } }, { children: Array.isArray(children) && children.length ? (_jsx(Chip, { label: children.length, sx: { transform: 'scale(0.8)' }, color: 'primary' })) : null }))] })) })) }, props, { nodeId: String(itemKey) }, { children: children }), itemKey) })));
}
export default ResultsTreeItem;
