import { __rest } from "tslib";
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import * as React from 'react';
import { Box } from '@mui/material';
export function Mark(props) {
    const { children, color, style } = props, _props = __rest(props, ["children", "color", "style"]);
    const defaultColor = 'rgba(0, 18, 255, 0.2)';
    const _style = {
        backgroundColor: color !== null && color !== void 0 ? color : defaultColor,
        padding: '0.1em 0.2em',
        borderRadius: '0.3em',
        border: `0.1em solid ${color !== null && color !== void 0 ? color : defaultColor}`,
        color: '#141414',
    };
    return (_jsx("mark", Object.assign({ style: Object.assign(Object.assign({}, _style), style) }, _props, { children: children })));
}
function Match(props) {
    const { children, replaced } = props;
    const { style, color } = replaced
        ? {
            color: 'rgba(218, 54, 51, 0.3)',
            style: { textDecoration: 'line-through' },
        }
        : {};
    return (_jsx(Mark, Object.assign({ style: style, color: color }, { children: children })));
}
function Replacement(props) {
    const { children } = props;
    const color = 'rgba(35, 134, 54, 0.3)';
    return _jsx(Mark, Object.assign({ color: color }, { children: children }));
}
export function SearchResult(props) {
    const { context = { before: '', after: '' }, match, replacement = '', ellipsis = '', minCtxWords = 5 } = props, other = __rest(props, ["context", "match", "replacement", "ellipsis", "minCtxWords"]);
    const { before, after } = context;
    const clippedBefore = React.useMemo(() => {
        const ctxArr = before.split(' ');
        const wordsCount = ctxArr.length;
        const selectedWordsCount = wordsCount - 1;
        const selectedCtxArr = ctxArr.slice(-selectedWordsCount);
        const wordsLimit = -minCtxWords;
        const slicedCtxArr = selectedCtxArr.slice(wordsLimit);
        const newCtxString = slicedCtxArr.join(' ');
        return newCtxString;
    }, [before, minCtxWords]);
    const clippedAfter = React.useMemo(() => {
        const ctxArr = after.split(' ');
        const wordsCount = ctxArr.length;
        const selectedWordsCount = wordsCount - 1;
        const selectedCtxArr = ctxArr.slice(0, selectedWordsCount);
        const wordsLimit = minCtxWords;
        const slicedCtxArr = selectedCtxArr.slice(0, wordsLimit);
        const newCtxString = slicedCtxArr.join(' ');
        return newCtxString;
    }, [after, minCtxWords]);
    return (_jsxs(Box, Object.assign({ component: 'span', width: '100%', variant: 'body1' }, other, { children: [ellipsis, clippedBefore, _jsx(Match, Object.assign({ replaced: !!replacement }, { children: match })), !replacement ? null : _jsx(Replacement, { children: replacement }), clippedAfter, ellipsis] })));
}
export default SearchResult;
